/*
    rc Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */

#define DR16
#ifdef AT9S
#include "device/at9s_pro.h"
#endif

#ifdef DR16
#include "device/dr16.h"
#endif
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
#ifdef AT9S
 uint8_t cmd_buffer[AT9S_FRAME_LEN];
 AT9S_t at9s;
#endif
#ifdef DR16
DR16_t dr16;
#endif
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_rc(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / RC_FREQ;

  osDelay(RC_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
  #ifdef AT9S
  AT9S_Init(&at9s);
  AT9S_StartDmaRecv(cmd_buffer);
  #endif
  #ifdef DR16
  DR16_Init(&dr16);
  #endif
  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
    #ifdef AT9S
    if (AT9S_WaitDmaCplt(10)) {
        AT9S_ParseRaw(cmd_buffer, &at9s);
        AT9S_StartDmaRecv(cmd_buffer);
    }
    osMessageQueuePut(task_runtime.msgq.cmd.rc, &at9s, 0, 0);
    #endif
    #ifdef DR16
    DR16_StartDmaRecv(&dr16);
    if (DR16_WaitDmaCplt(20)) {
      DR16_ParseData(&dr16);
    } else {
      DR16_Offline(&dr16);
    }
    osMessageQueueReset(task_runtime.msgq.cmd.rc);
    osMessageQueuePut(task_runtime.msgq.cmd.rc, &dr16, 0, 0);
    #endif
    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}
